// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "stack.h"

#include "MainFrm.h"
#include "NRDlgs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

   // create a view to occupy the client area of the frame
	if (!m_wndStack.Create(NULL, NULL, WS_CHILD | WS_VISIBLE,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

   if (!InitStackWindow())
   {
      TRACE0("Failed to initialize stack window\n");
      return -1;
   }

   return 0;
}

BOOL CMainFrame::InitStackWindow()
{
   CDialog* pDialog;

   pDialog = new CNRGeneralDlg;
   m_wndStack.InsertPage(pDialog, IDD_NR_GENERAL, _T("General"),
      SWF_VISIBLE);

   pDialog = new CNRTimeDlg;
   m_wndStack.InsertPage(pDialog, IDD_NR_TIME, _T("Time Output"),
      SWF_VISIBLE);

   pDialog = new CNRSizeDlg;
   m_wndStack.InsertPage(pDialog, IDD_NR_SIZE, _T("Output Size"),
      SWF_VISIBLE);

   pDialog = new CNROptionsDlg;
   m_wndStack.InsertPage(pDialog, IDD_NR_OPTIONS, _T("Advanced Options"),
      SWF_VISIBLE);

   return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
   cs.style &= ~WS_MAXIMIZEBOX;
   cs.style |= WS_MAXIMIZE;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndStack.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndStack.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	CFrameWnd::OnGetMinMaxInfo(lpMMI);

   CRect rect;
   GetClientRect(&rect);

   CSize sizeStack;
   if (m_wndStack.m_hWnd != NULL &&
       m_wndStack.SendMessage(LWM_CALCPANELSIZE, 0, (LPARAM)&sizeStack))
   {
      rect.right = sizeStack.cx;
      CalcWindowRect(&rect);
      lpMMI->ptMaxTrackSize.x = rect.Width();
      lpMMI->ptMaxSize.x = rect.Width();
   }

   lpMMI->ptMinTrackSize.x = 100;
   lpMMI->ptMinTrackSize.y = 100;
}
